<?php
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
/****     Konfiguration der Funktion      ****/
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/

// Die Variable $str_hyphen beinhaltet das Trennzeichen, welches die Ordner und
// Dateien trenn. Auf Windowssystemen ist es der Slash "/" und auf Unixsystemen
// ist es der Backslash "\". Hier wird jetzt aber immer der Backslash genutzt,
// weil Windows auch mit dem Backslash korrekt arbeitet.
//
// Beachten Sie bitte, dass der Backslash escaped werden muss, da es sonst zum
// "Parse error" kommt.
$str_hyphen = '\\';

// Die nun folgende Kontrollabfrage prueft, welches System Ihr Server nutzt.
// Dementsprechend wird der Wert fuer den Zeilenumbruch in der Variablen $str_nl
// gespeichert.
if(eregi('win', PHP_OS)){
    $str_nl = "<br>\r\n";
}elseif(eregi('mac', PHP_OS)){
    $str_nl = "<br>\r";
}else{
    $str_nl = "<br>\n";
}


/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
/****  Iterative Funktion "filelisting"   ****/
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/

function filelisting(){

    // Temporaerer Speicher
    $arr_buffer = array('.' . stripslashes($GLOBALS['str_hyphen']));

    // Durchlaufen des Temporaeren Speichers
    while($arr_buffer){

        // Erstes Array-Element in $str_path speichern und
        // aus Array loeschen
        $str_path = array_shift($arr_buffer);

        // Verzeichnis-Handle erstellen
        $res_dir = dir($str_path);

        // Durchlaufen der einzelnen Verzeichniseintraege
        while(false !== ($str_file = $res_dir->read())){

            // Ausmusterung von "." und ".." aus den
            // Verzeichniseintraegen
            if(($str_file !== '.') && ($str_file !== '..')){

                // Wenn Eintrag ein Ordner
                if(is_dir($str_path . $GLOBALS['str_hyphen'] . $str_file)){

                    // ...dann dem Temporaeren Speicher hinzufgen
                    $arr_buffer[] = $str_path . $GLOBALS['str_hyphen'] . $str_file;

                // Eintrag kein Ordner
                }else{

                    // ...dann Pfad und Dateinamen ausgeben
                    print $str_path . $GLOBALS['str_hyphen'] . $str_file . $GLOBALS['str_nl'];
                }
            }
        }

        // Verzeichnis schlieen
        $res_dir->close();
    }
}

// Aufruf der Funktion
filelisting();
?>