<?php
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
/****     Konfiguration der Funktion      ****/
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/

// Die Variable $str_hyphen beinhaltet das Trennzeichen, welches die Ordner und
// Dateien trenn. Auf Windowssystemen ist es der Slash "/" und auf Unixsystemen
// ist es der Backslash "\". Hier wird jetzt aber immer der Backslash genutzt,
// weil Windows auch mit dem Backslash korrekt arbeitet.
//
// Beachten Sie bitte, dass der Backslash escaped werden muss, da es sonst zum
// "Parse error" kommt.
$str_hyphen = '\\';

// Die nun folgende Kontrollabfrage prueft, welches System Ihr Server nutzt.
// Dementsprechend wird der Wert fuer den Zeilenumbruch in der Variablen $str_nl
// gespeichert.
if(eregi('win', PHP_OS)){
    $str_nl = "<br>\r\n";
}elseif(eregi('mac', PHP_OS)){
    $str_nl = "<br>\r";
}else{
    $str_nl = "<br>\n";
}


/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/
/****  Rekursive Funktion "filelisting"   ****/
/*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*+*/

function filelisting(){

    // Argumente laden
    $arr_args = func_get_args();

    // pruefen ob das einzigste Argument leer ist
    if(empty($arr_args[0])){

        // Uebergabe des Strings ".\" an $str_path
        $str_path = '.' . stripslashes($GLOBALS['str_hyphen']);

    }else{

        // Uebergabe des altuellen Pfads an $str_path
        $str_path = $arr_args[0];

    }

    // Verzeichnis-Handle anlegen
    $res_dir = dir($str_path);

    // Abarbeitung der Dateien und Ordner, im aktuellen Verzeichnis-Handle
    while($str_file = $res_dir->read()){

        // "." und ".." ignorieren
        if(($str_file !== '.') && ($str_file !== '..')){

            // Pruefen ob gueltiges Verzeichnis
            if(is_dir($str_path . $GLOBALS['str_hyphen'] . $str_file)){

                // Rekusiv Funktion "filelisting" aufrufen
                filelisting($str_path . $GLOBALS['str_hyphen'] . $str_file);
            }else{

                // Dateien ausgeben
                echo $str_path . $GLOBALS['str_hyphen'] . $str_file . $GLOBALS['str_nl'];
            }
        }
    }

    // Verzeichnis schlieen
    $res_dir->close();
}

// Aufruf der Funktion
filelisting();
?>